package com.jdbernard.timeanalyzer.events

import org.joda.time.ReadableDateTime
import org.joda.time.Duration
import org.joda.time.format.PeriodFormat
import org.joda.time.format.PeriodFormatter

public class Event implements Cloneable {

    public static PeriodFormatter periodFormatter = PeriodFormat.getDefault()

    public final String description
    public final String notes
    public final ReadableDateTime start
    public Duration duration    // should be final, allows modification for the
                                // TimelineEventProcessor

    public Event(String desc, String notes, ReadableDateTime start, Duration duration) {
        this.description = desc
        this.notes = notes
        this.start = start
        this.duration = duration }

    public Event(Map params) {
        this.description = params.description ?: ""
        this.notes = params.notes ?: ""
        this.start = params.start 
        this.duration = params.duration }

    public Event(Map params, Event e) {
        this.description = params.description ?: e.description
        this.notes = params.notes ?: e.notes
        this.start = params.start ?: e.start
        this.duration = params.duration ?: e.duration }

    public String toString() { 
        String period = periodFormatter.print(this.duration.toPeriod())
        return "${description} (${period})" }

}
